/* Copyright(C) 2011 Cobac.Net All rights reserved. */

module VGA(
    /* AvalonoX */
    input           CLK, RST,
    input   [11:0]  ADDR,
    input   [3:0]   BYTEEN,
    input           WRITE, READ,
    input   [31:0]  WRDATA,
    output  [31:0]  RDDATA,
    /* VGAo */
    output  reg [3:0]   VGA_R, VGA_G, VGA_B,
    output              VGA_HS, VGA_VS
);

wire    [9:0]   HCNT;
wire    [9:0]   VCNT;
wire            PCK;

/* HVJE^ڑ */
HVGEN HVGEN( .CLK(CLK), .RST(RST), .PCK(PCK),
  .VGA_HS(VGA_HS), .VGA_VS(VGA_VS), .HCNT(HCNT), .VCNT(VCNT) );

/* RAMڑM */
wire [31:0] vramout;
wire [11:0] rdaddr;
wire [11:0] vramaddr;

assign rdaddr = (READ) ? ADDR: vramaddr;
assign RDDATA  = vramout;

/* ǂݏ̓NbNiCLK̗オj */
VRAM    VRAM (
    .data ( WRDATA ),
    .wraddress ( ADDR ),
    .rdaddress ( rdaddr ),
    .wren ( WRITE ),
    .byteena_a( BYTEEN ),
    .clock ( CLK ),
    .q ( vramout )
    );

wire [2:0] vdotcnt;
wire [7:0] cgout;

/* ǂݏo̓NbN */
CGROM   CGROM (
    .address ( {vramout[6:0], vdotcnt} ),
    .q ( cgout ),
    .clock( PCK )
    );

/* HCNVCNT𕶎ƃhbg̃JE^Ƃĕčl */
wire [6:0] hchacnt = HCNT[9:3];  /* JE^   */
wire [2:0] hdotcnt = HCNT[2:0];  /* hbgJE^ */
wire [5:0] vchacnt = VCNT[8:3];  /* JE^   */
assign     vdotcnt = VCNT[2:0];  /* hbgJE^ */

/* VRAM̃AhX  vramaddr  vchacnt  80 { hchacnt */
assign vramaddr = (vchacnt<<6) + (vchacnt<<4) + hchacnt;

/* VtgWX^ */
reg [7:0] sreg;
wire sregld = (hdotcnt==3'h6 && HCNT<10'd640);

always @( posedge PCK, posedge RST ) begin
    if ( RST )
        sreg <= 8'h00;
    else if ( sregld )
        sreg <= cgout;
    else
        sreg <= {sreg[6:0], 1'b0};
end

/* FsregLDƓɎ荞 */
reg [11:0] rgb;

always @( posedge PCK, posedge RST ) begin
    if ( RST )
        rgb <= 12'h000;
    else if ( sregld )
        rgb <= vramout[27:16];
end

/* A\Cl[uM */
wire hdispen = (10'd7<=HCNT && HCNT<10'd647);
wire vdispen = (VCNT<9'd400);

/* RGBo͐M쐬 */
always @( posedge PCK, posedge RST ) begin
    if ( RST )
        {VGA_R, VGA_G, VGA_B} <= 12'h000;
    else
        {VGA_R, VGA_G, VGA_B} <=
            rgb & {12{hdispen & vdispen}} & {12{sreg[7]}};
end

endmodule
